Remove misleading debug line entries
[official-gcc.git] / libgo / mksysinfo.sh
blobb32a0266b719f5856cc35961cfcffd36883d8938
1 #!/bin/sh
3 # Copyright 2009 The Go Authors. All rights reserved.
4 # Use of this source code is governed by a BSD-style
5 # license that can be found in the LICENSE file.
7 # Create sysinfo.go from gen-sysinfo.go and errno.i.
9 # This shell script creates the sysinfo.go file which holds types and
10 # constants extracted from the system header files. This reads the
11 # raw data from gen-sysinfo.go which is generated using the
12 # -fdump-go-spec option.
14 # This currently exposes some names that ideally should not be
15 # exposed, as they match grep patterns. E.g., WCHAR_MIN gets exposed
16 # because it starts with W, like the wait flags.
18 OUT=tmp-sysinfo.go
20 set -e
22 echo 'package syscall' > ${OUT}
23 echo 'import "unsafe"' >> ${OUT}
24 echo 'type _ unsafe.Pointer' >> ${OUT}
26 # Get all the consts and types, skipping ones which could not be
27 # represented in Go and ones which we need to rewrite. We also skip
28 # function declarations, as we don't need them here. All the symbols
29 # will all have a leading underscore.
30 grep -v '^// ' gen-sysinfo.go | \
31 grep -v '^func' | \
32 grep -v '^var' | \
33 grep -v '^type _timeval ' | \
34 grep -v '^type _timespec_t ' | \
35 grep -v '^type _timespec ' | \
36 grep -v '^type _timestruc_t ' | \
37 grep -v '^type _epoll_' | \
38 grep -v '^type _*locale[_ ]' | \
39 grep -v 'in6_addr' | \
40 grep -v 'sockaddr_in6' | \
41 sed -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
42 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
43 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
44 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
45 >> ${OUT}
47 # On AIX, the _arpcom struct, is filtered by the above grep sequence, as it as
48 # a field of type _in6_addr, but other types depend on _arpcom, so we need to
49 # put it back.
50 grep '^type _arpcom ' gen-sysinfo.go | \
51 sed -e 's/_in6_addr/[16]byte/' >> ${OUT}
53 # Same on Solaris for _mld_hdr_t.
54 grep '^type _mld_hdr_t ' gen-sysinfo.go | \
55 sed -e 's/_in6_addr/[16]byte/' >> ${OUT}
57 # The errno constants. These get type Errno.
58 egrep '#define E[A-Z0-9_]+ [0-9E]' errno.i | \
59 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(_\1)/' >> ${OUT}
61 # Workaround for GNU/Hurd _EMIG_* errors having negative values
62 egrep '#define E[A-Z0-9_]+ -[0-9]' errno.i | \
63 sed -e 's/^#define \(E[A-Z0-9_]*\) .*$/const \1 = Errno(-_\1)/' >> ${OUT}
65 # The O_xxx flags.
66 egrep '^const _(O|F|FD)_' gen-sysinfo.go | \
67 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
68 if ! grep '^const O_ASYNC' ${OUT} >/dev/null 2>&1; then
69 echo "const O_ASYNC = 0" >> ${OUT}
71 if ! grep '^const O_CLOEXEC' ${OUT} >/dev/null 2>&1; then
72 echo "const O_CLOEXEC = 0" >> ${OUT}
75 # The os package requires F_DUPFD_CLOEXEC to be defined.
76 if ! grep '^const F_DUPFD_CLOEXEC' ${OUT} >/dev/null 2>&1; then
77 echo "const F_DUPFD_CLOEXEC = 0" >> ${OUT}
80 # The internal/poll package requires F_GETPIPE_SZ to be defined.
81 if ! grep '^const F_GETPIPE_SZ' ${OUT} >/dev/null 2>&1; then
82 echo "const F_GETPIPE_SZ = 0" >> ${OUT}
85 # AIX 7.1 is a 64 bits value for _FCLOEXEC (referenced by O_CLOEXEC)
86 # which leads to a constant overflow when using O_CLOEXEC in some
87 # go code. Issue wan not present in 6.1 (no O_CLOEXEC) and is no
88 # more present in 7.2 (_FCLOEXEC is a 32 bit value).
89 if test "${GOOS}" = "aix" && `oslevel | grep -q "^7.1"`; then
90 sed -e 's/const __FCLOEXEC = .*/const __FCLOEXEC = 0/' ${OUT} > ${OUT}-2
91 mv ${OUT}-2 ${OUT}
94 # These flags can be lost on i386 GNU/Linux when using
95 # -D_FILE_OFFSET_BITS=64, because we see "#define F_SETLK F_SETLK64"
96 # before we see the definition of F_SETLK64.
97 for flag in F_GETLK F_SETLK F_SETLKW; do
98 if ! grep "^const ${flag} " ${OUT} >/dev/null 2>&1 \
99 && grep "^const ${flag}64 " ${OUT} >/dev/null 2>&1; then
100 echo "const ${flag} = ${flag}64" >> ${OUT}
102 done
104 # The Flock_t struct for fcntl.
105 grep '^type _flock ' gen-sysinfo.go | \
106 sed -e 's/type _flock/type Flock_t/' \
107 -e 's/l_type/Type/' \
108 -e 's/l_whence/Whence/' \
109 -e 's/l_start/Start/' \
110 -e 's/l_len/Len/' \
111 -e 's/l_pid/Pid/' \
112 >> ${OUT}
114 # The signal numbers.
115 grep '^const _SIG[^_]' gen-sysinfo.go | \
116 grep -v '^const _SIGEV_' | \
117 sed -e 's/^\(const \)_\(SIG[^= ]*\)\(.*\)$/\1\2 = Signal(_\2)/' >> ${OUT}
118 if ! grep '^const SIGPOLL ' ${OUT} >/dev/null 2>&1; then
119 if grep '^const SIGIO ' ${OUT} > /dev/null 2>&1; then
120 echo "const SIGPOLL = SIGIO" >> ${OUT}
123 if ! grep '^const SIGCLD ' ${OUT} >/dev/null 2>&1; then
124 if grep '^const SIGCHLD ' ${OUT} >/dev/null 2>&1; then
125 echo "const SIGCLD = SIGCHLD" >> ${OUT}
129 # The syscall numbers. We force the names to upper case.
130 grep '^const _SYS_' gen-sysinfo.go | \
131 sed -e 's/const _\(SYS_[^= ]*\).*$/\1/' | \
132 while read sys; do
133 sup=`echo $sys | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
134 echo "const $sup = _$sys" >> ${OUT}
135 done
137 # Special treatment of SYS_IOCTL for GNU/Hurd.
138 if ! grep '^const SYS_IOCTL' ${OUT} > /dev/null 2>&1; then
139 echo "const SYS_IOCTL = 0" >> ${OUT}
142 # The GNU/Linux support wants to use SYS_GETDENTS64 if available.
143 if ! grep '^const SYS_GETDENTS ' ${OUT} >/dev/null 2>&1; then
144 echo "const SYS_GETDENTS = 0" >> ${OUT}
146 if ! grep '^const SYS_GETDENTS64 ' ${OUT} >/dev/null 2>&1; then
147 echo "const SYS_GETDENTS64 = 0" >> ${OUT}
150 # The syscall package wants the geteuid system call number. It isn't
151 # defined on Alpha, which only provides the getresuid system call.
152 if ! grep '^const SYS_GETEUID ' ${OUT} >/dev/null 2>&1; then
153 echo "const SYS_GETEUID = 0" >> ${OUT}
156 # Stat constants.
157 grep '^const _S_' gen-sysinfo.go | \
158 sed -e 's/^\(const \)_\(S_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
160 # Mmap constants.
161 grep '^const _PROT_' gen-sysinfo.go | \
162 sed -e 's/^\(const \)_\(PROT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
163 grep '^const _MAP_' gen-sysinfo.go | \
164 sed -e 's/^\(const \)_\(MAP_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
165 grep '^const _MADV_' gen-sysinfo.go | \
166 sed -e 's/^\(const \)_\(MADV_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
167 grep '^const _MCL_' gen-sysinfo.go | \
168 sed -e 's/^\(const \)_\(MCL_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
170 # Process status constants.
171 grep '^const _W' gen-sysinfo.go |
172 sed -e 's/^\(const \)_\(W[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
173 # WSTOPPED was introduced in glibc 2.3.4.
174 if ! grep '^const _WSTOPPED = ' gen-sysinfo.go >/dev/null 2>&1; then
175 if grep '^const _WUNTRACED = ' gen-sysinfo.go > /dev/null 2>&1; then
176 echo 'const WSTOPPED = _WUNTRACED' >> ${OUT}
177 else
178 echo 'const WSTOPPED = 2' >> ${OUT}
181 if grep '^const ___WALL = ' gen-sysinfo.go >/dev/null 2>&1 \
182 && ! grep '^const _WALL = ' gen-sysinfo.go >/dev/null 2>&1; then
183 echo 'const WALL = ___WALL' >> ${OUT}
185 # On GNU/Linux the os package requires WEXITED and WNOWAIT.
186 if test "${GOOS}" = "linux"; then
187 if ! grep '^const WEXITED = ' ${OUT} >/dev/null 2>&1; then
188 echo 'const WEXITED = 4' >> ${OUT}
190 if ! grep '^const WNOWAIT = ' ${OUT} >/dev/null 2>&1; then
191 echo 'const WNOWAIT = 0x01000000' >> ${OUT}
195 # Networking constants.
196 egrep '^const _(AF|ARPHRD|ETH|IN|SOCK|SOL|SO|IPPROTO|TCP|IP|IPV6)_' gen-sysinfo.go |
197 grep -v '_val =' |
198 sed -e 's/^\(const \)_\([^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
199 grep '^const _SOMAXCONN' gen-sysinfo.go |
200 sed -e 's/^\(const \)_\(SOMAXCONN[^= ]*\)\(.*\)$/\1\2 = _\2/' \
201 >> ${OUT}
202 grep '^const _SHUT_' gen-sysinfo.go |
203 sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
205 # The net package requires some const definitions.
206 for m in IP_PKTINFO IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP IPV6_TCLASS SO_REUSEPORT; do
207 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
208 echo "const $m = 0" >> ${OUT}
210 done
211 for m in SOCK_CLOEXEC SOCK_NONBLOCK; do
212 if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
213 echo "const $m = -1" >> ${OUT}
215 done
217 # On 32-bit GNU/Linux the expression for SO_RCVTIMEO is too complicated
218 # for -fdump-go-spec.
219 if ! grep '^const SO_RCVTIMEO ' ${OUT} >/dev/null 2>&1; then
220 if grep '^const _SO_RCVTIMEO_val' ${OUT} >/dev/null 2>&1; then
221 echo 'const SO_RCVTIMEO = _SO_RCVTIMEO_val' >> ${OUT}
225 # The syscall package requires AF_LOCAL.
226 if ! grep '^const AF_LOCAL ' ${OUT} >/dev/null 2>&1; then
227 if grep '^const AF_UNIX ' ${OUT} >/dev/null 2>&1; then
228 echo "const AF_LOCAL = AF_UNIX" >> ${OUT}
232 # The syscall package requires _AT_FDCWD, but doesn't export it.
233 if ! grep '^const _AT_FDCWD = ' ${OUT} >/dev/null 2>&1; then
234 echo "const _AT_FDCWD = -100" >> ${OUT}
237 # sysctl constants.
238 grep '^const _CTL' gen-sysinfo.go |
239 sed -e 's/^\(const \)_\(CTL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
240 grep '^const _SYSCTL' gen-sysinfo.go |
241 sed -e 's/^\(const \)_\(SYSCTL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
242 grep '^const _NET_RT' gen-sysinfo.go |
243 sed -e 's/^\(const \)_\(NET_RT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
245 # The sysctlnode struct.
246 grep '^type _sysctlnode ' gen-sysinfo.go | \
247 sed -e 's/_sysctlnode/Sysctlnode/' \
248 -e 's/sysctl_flags/Flags/' \
249 -e 's/sysctl_name/Name/' \
250 -e 's/sysctl_num/Num/' \
251 >> ${OUT}
253 # sysconf constants.
254 grep '^const __SC' gen-sysinfo.go |
255 sed -e 's/^\(const \)__\(SC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
257 # pathconf constants.
258 grep '^const __PC' gen-sysinfo.go |
259 sed -e 's/^\(const \)__\(PC[^= ]*\)\(.*\)$/\1\2 = __\2/' >> ${OUT}
261 # The PATH_MAX constant.
262 if grep '^const _PATH_MAX ' gen-sysinfo.go >/dev/null 2>&1; then
263 echo 'const PathMax = _PATH_MAX' >> ${OUT}
266 # epoll constants.
267 grep '^const _EPOLL' gen-sysinfo.go |
268 grep -v EPOLLET |
269 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
270 # Make sure EPOLLET is positive.
271 if grep '^const _EPOLLET = [0-9]' gen-sysinfo.go >/dev/null 2>&1; then
272 grep '^const _EPOLLET ' gen-sysinfo.go |
273 sed -e 's/^\(const \)_\(EPOLL[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
274 else
275 echo "const EPOLLET = 0x80000000" >> ${OUT}
277 # Make sure EPOLLRDHUP and EPOLL_CLOEXEC are defined.
278 if ! grep '^const EPOLLRDHUP' ${OUT} >/dev/null 2>&1; then
279 echo "const EPOLLRDHUP = 0x2000" >> ${OUT}
281 if ! grep '^const EPOLL_CLOEXEC' ${OUT} >/dev/null 2>&1; then
282 echo "const EPOLL_CLOEXEC = 02000000" >> ${OUT}
285 # Prctl constants.
286 grep '^const _PR_' gen-sysinfo.go |
287 sed -e 's/^\(const \)_\(PR_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
289 # Ptrace constants.
290 grep '^const _PTRACE' gen-sysinfo.go |
291 sed -e 's/^\(const \)_\(PTRACE[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
292 # We need some ptrace options that are not defined in older versions
293 # of glibc.
294 if ! grep '^const PTRACE_SETOPTIONS' ${OUT} > /dev/null 2>&1; then
295 echo "const PTRACE_SETOPTIONS = 0x4200" >> ${OUT}
297 if ! grep '^const PTRACE_O_TRACESYSGOOD' ${OUT} > /dev/null 2>&1; then
298 echo "const PTRACE_O_TRACESYSGOOD = 0x1" >> ${OUT}
300 if ! grep '^const PTRACE_O_TRACEFORK' ${OUT} > /dev/null 2>&1; then
301 echo "const PTRACE_O_TRACEFORK = 0x2" >> ${OUT}
303 if ! grep '^const PTRACE_O_TRACEVFORK' ${OUT} > /dev/null 2>&1; then
304 echo "const PTRACE_O_TRACEVFORK = 0x4" >> ${OUT}
306 if ! grep '^const PTRACE_O_TRACECLONE' ${OUT} > /dev/null 2>&1; then
307 echo "const PTRACE_O_TRACECLONE = 0x8" >> ${OUT}
309 if ! grep '^const PTRACE_O_TRACEEXEC' ${OUT} > /dev/null 2>&1; then
310 echo "const PTRACE_O_TRACEEXEC = 0x10" >> ${OUT}
312 if ! grep '^const PTRACE_O_TRACEVFORKDONE' ${OUT} > /dev/null 2>&1; then
313 echo "const PTRACE_O_TRACEVFORKDONE = 0x20" >> ${OUT}
315 if ! grep '^const PTRACE_O_TRACEEXIT' ${OUT} > /dev/null 2>&1; then
316 echo "const PTRACE_O_TRACEEXIT = 0x40" >> ${OUT}
318 if ! grep '^const PTRACE_O_MASK' ${OUT} > /dev/null 2>&1; then
319 echo "const PTRACE_O_MASK = 0x7f" >> ${OUT}
321 if ! grep '^const _PTRACE_GETEVENTMSG' ${OUT} > /dev/null 2>&1; then
322 echo "const PTRACE_GETEVENTMSG = 0x4201" >> ${OUT}
324 if ! grep '^const PTRACE_EVENT_FORK' ${OUT} > /dev/null 2>&1; then
325 echo "const PTRACE_EVENT_FORK = 1" >> ${OUT}
327 if ! grep '^const PTRACE_EVENT_VFORK' ${OUT} > /dev/null 2>&1; then
328 echo "const PTRACE_EVENT_VFORK = 2" >> ${OUT}
330 if ! grep '^const PTRACE_EVENT_CLONE' ${OUT} > /dev/null 2>&1; then
331 echo "const PTRACE_EVENT_CLONE = 3" >> ${OUT}
333 if ! grep '^const PTRACE_EVENT_EXEC' ${OUT} > /dev/null 2>&1; then
334 echo "const PTRACE_EVENT_EXEC = 4" >> ${OUT}
336 if ! grep '^const PTRACE_EVENT_VFORK_DONE' ${OUT} > /dev/null 2>&1; then
337 echo "const PTRACE_EVENT_VFORK_DONE = 5" >> ${OUT}
339 if ! grep '^const PTRACE_EVENT_EXIT' ${OUT} > /dev/null 2>&1; then
340 echo "const PTRACE_EVENT_EXIT = 6" >> ${OUT}
342 if ! grep '^const _PTRACE_TRACEME' ${OUT} > /dev/null 2>&1; then
343 echo "const _PTRACE_TRACEME = 0" >> ${OUT}
346 # A helper function that prints a structure from gen-sysinfo.go with the first
347 # letter of the field names in upper case. $1 is the name of structure. If $2
348 # is not empty, the structure or type is renamed to $2.
349 upcase_fields () {
350 name="$1"
351 def=`grep "^type $name " gen-sysinfo.go`
352 fields=`echo $def | sed -e 's/^[^{]*{\(.*\)}$/\1/'`
353 prefix=`echo $def | sed -e 's/{.*//'`
354 if test "$2" != ""; then
355 prefix=`echo $prefix | sed -e "s/$1/$2/"`
357 if test "$fields" != ""; then
358 nfields=
359 while test -n "$fields"; do
360 field=`echo $fields | sed -e 's/^\([^;]*\);.*$/\1/'`
361 fields=`echo $fields | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
362 # capitalize the next character.
363 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
364 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
365 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
366 field="$f$r"
367 nfields="$nfields $field;"
368 done
369 echo "${prefix} {$nfields }"
373 # The registers returned by PTRACE_GETREGS. This is probably
374 # GNU/Linux specific; it should do no harm if there is no
375 # _user_regs_struct.
376 regs=`grep '^type _user_regs_struct struct' gen-sysinfo.go || true`
377 if test "$regs" = ""; then
378 # mips*
379 regs=`grep '^type _pt_regs struct' gen-sysinfo.go || true`
381 if test "$regs" != ""; then
382 regs=`echo $regs | sed -e 's/type _pt_regs struct//'`
383 regs=`echo $regs |
384 sed -e 's/type __*user_regs_struct struct //' -e 's/[{}]//g'`
385 regs=`echo $regs | sed -e s'/^ *//'`
386 nregs=
387 while test -n "$regs"; do
388 field=`echo $regs | sed -e 's/^\([^;]*\);.*$/\1/'`
389 regs=`echo $regs | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
390 # Capitalize the first character of the field.
391 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
392 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
393 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
394 field="$f$r"
395 field=`echo "$field" | sed \
396 -e 's/__user_psw_struct/PtracePsw/' \
397 -e 's/__user_fpregs_struct/PtraceFpregs/' \
398 -e 's/__user_per_struct/PtracePer/'`
399 nregs="$nregs $field;"
400 done
401 echo "type PtraceRegs struct {$nregs }" >> ${OUT}
404 # Some basic types.
405 echo 'type Size_t _size_t' >> ${OUT}
406 echo "type Ssize_t _ssize_t" >> ${OUT}
407 if grep '^const _HAVE_OFF64_T = ' gen-sysinfo.go > /dev/null 2>&1; then
408 echo "type Offset_t _off64_t" >> ${OUT}
409 else
410 echo "type Offset_t _off_t" >> ${OUT}
412 echo "type Mode_t _mode_t" >> ${OUT}
413 echo "type Pid_t _pid_t" >> ${OUT}
414 echo "type Uid_t _uid_t" >> ${OUT}
415 echo "type Gid_t _gid_t" >> ${OUT}
416 echo "type Socklen_t _socklen_t" >> ${OUT}
418 # The C int type.
419 sizeof_int=`grep '^const ___SIZEOF_INT__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
420 if test "$sizeof_int" = "4"; then
421 echo "type _C_int int32" >> ${OUT}
422 echo "type _C_uint uint32" >> ${OUT}
423 elif test "$sizeof_int" = "8"; then
424 echo "type _C_int int64" >> ${OUT}
425 echo "type _C_uint uint64" >> ${OUT}
426 else
427 echo 1>&2 "mksysinfo.sh: could not determine size of int (got $sizeof_int)"
428 exit 1
431 # The C long type, needed because that is the type that ptrace returns.
432 sizeof_long=`grep '^const ___SIZEOF_LONG__ = ' gen-sysinfo.go | sed -e 's/.*= //'`
433 if test "$sizeof_long" = "4"; then
434 echo "type _C_long int32" >> ${OUT}
435 echo "type _C_ulong uint32" >> ${OUT}
436 elif test "$sizeof_long" = "8"; then
437 echo "type _C_long int64" >> ${OUT}
438 echo "type _C_ulong uint64" >> ${OUT}
439 else
440 echo 1>&2 "mksysinfo.sh: could not determine size of long (got $sizeof_long)"
441 exit 1
444 # Solaris 2 needs _u?pad128_t, but its default definition in terms of long
445 # double is commented by -fdump-go-spec.
446 if grep "^// type _pad128_t" gen-sysinfo.go > /dev/null 2>&1; then
447 echo "type _pad128_t struct { _l [4]int32; }" >> ${OUT}
449 if grep "^// type _upad128_t" gen-sysinfo.go > /dev/null 2>&1; then
450 echo "type _upad128_t struct { _l [4]uint32; }" >> ${OUT}
453 # The time_t type.
454 if grep '^type _time_t ' gen-sysinfo.go > /dev/null 2>&1; then
455 echo 'type Time_t _time_t' >> ${OUT}
458 # The time structures need special handling: we need to name the
459 # types, so that we can cast integers to the right types when
460 # assigning to the structures.
461 timeval=`grep '^type _timeval ' gen-sysinfo.go`
462 timeval_sec=`echo $timeval | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
463 timeval_usec=`echo $timeval | sed -n -e 's/^.*tv_usec \([^ ]*\);.*$/\1/p'`
464 echo "type Timeval_sec_t = $timeval_sec" >> ${OUT}
465 echo "type Timeval_usec_t = $timeval_usec" >> ${OUT}
466 echo $timeval | \
467 sed -e 's/type _timeval /type Timeval /' \
468 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timeval_sec_t/' \
469 -e 's/tv_usec *[a-zA-Z0-9_]*/Usec Timeval_usec_t/' >> ${OUT}
470 timespec=`grep '^type _timespec ' gen-sysinfo.go || true`
471 if test "$timespec" = ""; then
472 # IRIX 6.5 has __timespec instead.
473 timespec=`grep '^type ___timespec ' gen-sysinfo.go || true`
475 timespec_sec=`echo $timespec | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
476 timespec_nsec=`echo $timespec | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
477 echo "type Timespec_sec_t = $timespec_sec" >> ${OUT}
478 echo "type Timespec_nsec_t = $timespec_nsec" >> ${OUT}
479 echo $timespec | \
480 sed -e 's/^type ___timespec /type Timespec /' \
481 -e 's/^type _timespec /type Timespec /' \
482 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timespec_sec_t/' \
483 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timespec_nsec_t/' >> ${OUT}
485 timestruc=`grep '^type _timestruc_t ' gen-sysinfo.go || true`
486 if test "$timestruc" != ""; then
487 timestruc_sec=`echo $timestruc | sed -n -e 's/^.*tv_sec \([^ ]*\);.*$/\1/p'`
488 timestruc_nsec=`echo $timestruc | sed -n -e 's/^.*tv_nsec \([^ ]*\);.*$/\1/p'`
489 echo "type Timestruc_sec_t = $timestruc_sec" >> ${OUT}
490 echo "type Timestruc_nsec_t = $timestruc_nsec" >> ${OUT}
491 echo $timestruc | \
492 sed -e 's/^type _timestruc_t /type Timestruc /' \
493 -e 's/tv_sec *[a-zA-Z0-9_]*/Sec Timestruc_sec_t/' \
494 -e 's/tv_nsec *[a-zA-Z0-9_]*/Nsec Timestruc_nsec_t/' >> ${OUT}
497 # The tms struct.
498 grep '^type _tms ' gen-sysinfo.go | \
499 sed -e 's/type _tms/type Tms/' \
500 -e 's/tms_utime/Utime/' \
501 -e 's/tms_stime/Stime/' \
502 -e 's/tms_cutime/Cutime/' \
503 -e 's/tms_cstime/Cstime/' \
504 >> ${OUT}
506 # AIX uses st_timespec struct for stat.
507 grep '^type _st_timespec ' gen-sysinfo.go | \
508 sed -e 's/type _st_timespec /type StTimespec /' \
509 -e 's/tv_sec/Sec/' \
510 -e 's/tv_nsec/Nsec/' >> ${OUT}
512 # Special treatment of struct stat st_dev for GNU/Hurd
513 # /usr/include/i386-gnu/bits/stat.h: #define st_dev st_fsid
514 st_dev='-e s/st_dev/Dev/'
515 if grep 'define st_dev st_fsid' gen-sysinfo.go > /dev/null 2>&1; then
516 st_dev='-e s/st_fsid/Dev/'
519 # For historical reasons Go uses the suffix "timespec" instead of "tim" for
520 # stat_t's time fields on NetBSD.
521 st_times='-e s/st_atim/Atim/ -e s/st_mtim/Mtim/ -e s/st_ctim/Ctim/'
522 if test "${GOOS}" = "netbsd"; then
523 st_times='-e s/st_atim/Atimespec/ -e s/st_mtim/Mtimespec/ -e s/st_ctim/Ctimespec/'
526 # The stat type.
527 # Prefer largefile variant if available.
528 stat=`grep '^type _stat64 ' gen-sysinfo.go || true`
529 if test "$stat" != ""; then
530 grep '^type _stat64 ' gen-sysinfo.go
531 else
532 grep '^type _stat ' gen-sysinfo.go
533 fi | sed -e 's/type _stat64/type Stat_t/' \
534 -e 's/type _stat/type Stat_t/' \
535 ${st_dev} \
536 ${st_times} \
537 -e 's/st_ino/Ino/g' \
538 -e 's/st_nlink/Nlink/' \
539 -e 's/st_mode/Mode/' \
540 -e 's/st_uid/Uid/' \
541 -e 's/st_gid/Gid/' \
542 -e 's/st_rdev/Rdev/' \
543 -e 's/st_size/Size/' \
544 -e 's/st_blksize/Blksize/' \
545 -e 's/st_blocks/Blocks/' \
546 -e 's/\([^a-zA-Z0-9_]\)_timeval\([^a-zA-Z0-9_]\)/\1Timeval\2/g' \
547 -e 's/\([^a-zA-Z0-9_]\)_timespec_t\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
548 -e 's/\([^a-zA-Z0-9_]\)_st_timespec_t\([^a-zA-Z0-9_]\)/\1StTimespec\2/g' \
549 -e 's/\([^a-zA-Z0-9_]\)_timespec\([^a-zA-Z0-9_]\)/\1Timespec\2/g' \
550 -e 's/\([^a-zA-Z0-9_]\)_timestruc_t\([^a-zA-Z0-9_]\)/\1Timestruc\2/g' \
551 -e 's/Godump_[0-9] struct { \([^;]*;\) };/\1/g' \
552 >> ${OUT}
554 # The directory searching types.
555 # Prefer largefile variant if available.
556 dirent=`grep '^type _dirent64 ' gen-sysinfo.go || true`
557 if test "$dirent" != ""; then
558 grep '^type _dirent64 ' gen-sysinfo.go
559 else
560 grep '^type _dirent ' gen-sysinfo.go
561 fi | sed -e 's/type _dirent64/type Dirent/' \
562 -e 's/type _dirent/type Dirent/' \
563 -e 's/d_name \[0+1\]/d_name [0+256]/' \
564 -e 's/d_name/Name/' \
565 -e 's/]int8/]byte/' \
566 -e 's/d_fileno/Fileno/' \
567 -e 's/d_ino/Ino/' \
568 -e 's/d_namlen/Namlen/' \
569 -e 's/d_off/Off/' \
570 -e 's/d_reclen/Reclen/' \
571 -e 's/d_type/Type/' \
572 >> ${OUT}
573 echo "type DIR _DIR" >> ${OUT}
575 # Values for d_type field in dirent.
576 grep '^const _DT_' gen-sysinfo.go |
577 sed -e 's/^\(const \)_\(DT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
579 # The rusage struct.
580 rusage=`grep '^type _rusage struct' gen-sysinfo.go`
581 if test "$rusage" != ""; then
582 # Remove anonymous unions from GNU/Linux <bits/resource.h>.
583 rusage=`echo $rusage | sed -e 's/Godump_[0-9][0-9]* struct {\([^}]*\)};/\1/g'`
584 rusage=`echo $rusage | sed -e 's/type _rusage struct //' -e 's/[{}]//g'`
585 rusage=`echo $rusage | sed -e 's/^ *//'`
586 nrusage=
587 while test -n "$rusage"; do
588 field=`echo $rusage | sed -e 's/^\([^;]*\);.*$/\1/'`
589 rusage=`echo $rusage | sed -e 's/^[^;]*; *\(.*\)$/\1/'`
590 # Drop the leading ru_, capitalize the next character.
591 field=`echo $field | sed -e 's/^ru_//'`
592 f=`echo $field | sed -e 's/^\(.\).*$/\1/'`
593 r=`echo $field | sed -e 's/^.\(.*\)$/\1/'`
594 f=`echo $f | tr abcdefghijklmnopqrstuvwxyz ABCDEFGHIJKLMNOPQRSTUVWXYZ`
595 # Fix _timeval _timespec, and _timestruc_t.
596 r=`echo $r | sed -e s'/ _timeval$/ Timeval/'`
597 r=`echo $r | sed -e s'/ _timespec$/ Timespec/'`
598 r=`echo $r | sed -e s'/ _timestruc_t$/ Timestruc/'`
599 field="$f$r"
600 nrusage="$nrusage $field;"
601 done
602 echo "type Rusage struct {$nrusage }" >> ${OUT}
603 else
604 echo "type Rusage struct {}" >> ${OUT}
607 # The RUSAGE constants.
608 grep '^const _RUSAGE_' gen-sysinfo.go | \
609 sed -e 's/^\(const \)_\(RUSAGE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
611 # The utsname struct.
612 grep '^type _utsname ' gen-sysinfo.go | \
613 sed -e 's/_utsname/Utsname/' \
614 -e 's/sysname/Sysname/' \
615 -e 's/nodename/Nodename/' \
616 -e 's/release/Release/' \
617 -e 's/version/Version/' \
618 -e 's/machine/Machine/' \
619 -e 's/domainname/Domainname/' \
620 >> ${OUT}
622 # The iovec struct.
623 iovec=`grep '^type _iovec ' gen-sysinfo.go`
624 iovec_len=`echo $iovec | sed -n -e 's/^.*iov_len \([^ ]*\);.*$/\1/p'`
625 echo "type Iovec_len_t $iovec_len" >> ${OUT}
626 echo $iovec | \
627 sed -e 's/_iovec/Iovec/' \
628 -e 's/iov_base/Base/' \
629 -e 's/iov_len *[a-zA-Z0-9_]*/Len Iovec_len_t/' \
630 >> ${OUT}
632 # The msghdr struct.
633 msghdr=`grep '^type _msghdr ' gen-sysinfo.go`
634 msghdr_controllen=`echo $msghdr | sed -n -e 's/^.*msg_controllen \([^ ]*\);.*$/\1/p'`
635 echo "type Msghdr_controllen_t $msghdr_controllen" >> ${OUT}
636 echo $msghdr | \
637 sed -e 's/_msghdr/Msghdr/' \
638 -e 's/msg_name/Name/' \
639 -e 's/msg_namelen/Namelen/' \
640 -e 's/msg_iov/Iov/' \
641 -e 's/msg_iovlen/Iovlen/' \
642 -e 's/_iovec/Iovec/' \
643 -e 's/msg_control/Control/' \
644 -e 's/msg_controllen *[a-zA-Z0-9_]*/Controllen Msghdr_controllen_t/' \
645 -e 's/msg_flags/Flags/' \
646 >> ${OUT}
648 # The MSG_ flags for Msghdr.
649 grep '^const _MSG_' gen-sysinfo.go | \
650 sed -e 's/^\(const \)_\(MSG_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
652 # The cmsghdr struct.
653 cmsghdr=`grep '^type _cmsghdr ' gen-sysinfo.go`
654 if test -n "$cmsghdr"; then
655 cmsghdr_len=`echo $cmsghdr | sed -n -e 's/^.*cmsg_len \([^ ]*\);.*$/\1/p'`
656 echo "type Cmsghdr_len_t $cmsghdr_len" >> ${OUT}
657 echo "$cmsghdr" | \
658 sed -e 's/_cmsghdr/Cmsghdr/' \
659 -e 's/cmsg_len *[a-zA-Z0-9_]*/Len Cmsghdr_len_t/' \
660 -e 's/cmsg_level/Level/' \
661 -e 's/cmsg_type/Type/' \
662 -e 's/\[\]/[0]/' \
663 >> ${OUT}
666 # The SCM_ flags for Cmsghdr.
667 grep '^const _SCM_' gen-sysinfo.go | \
668 sed -e 's/^\(const \)_\(SCM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
670 # The ucred struct.
671 upcase_fields "_ucred" "Ucred" >> ${OUT} || true
673 # The ip_mreq struct.
674 grep '^type _ip_mreq ' gen-sysinfo.go | \
675 sed -e 's/_ip_mreq/IPMreq/' \
676 -e 's/imr_multiaddr/Multiaddr/' \
677 -e 's/imr_interface/Interface/' \
678 -e 's/_in_addr/[4]byte/g' \
679 >> ${OUT}
681 # We need IPMreq to compile the net package.
682 if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
683 echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
686 # The ipv6_mreq struct.
687 grep '^type _ipv6_mreq ' gen-sysinfo.go | \
688 sed -e 's/_ipv6_mreq/IPv6Mreq/' \
689 -e 's/ipv6mr_multiaddr/Multiaddr/' \
690 -e 's/ipv6mr_interface/Interface/' \
691 -e 's/_in6_addr/[16]byte/' \
692 >> ${OUT}
694 # We need IPv6Mreq to compile the net package.
695 if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
696 echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
699 # The ip_mreqn struct.
700 grep '^type _ip_mreqn ' gen-sysinfo.go | \
701 sed -e 's/_ip_mreqn/IPMreqn/' \
702 -e 's/imr_multiaddr/Multiaddr/' \
703 -e 's/imr_address/Address/' \
704 -e 's/imr_ifindex/Ifindex/' \
705 -e 's/_in_addr/[4]byte/g' \
706 >> ${OUT}
708 # We need IPMreq to compile the net package.
709 if ! grep 'type IPMreqn ' ${OUT} >/dev/null 2>&1; then
710 echo 'type IPMreqn struct { Multiaddr [4]byte; Interface [4]byte; Ifindex int32 }' >> ${OUT}
713 # The icmp6_filter struct.
714 grep '^type _icmp6_filter ' gen-sysinfo.go | \
715 sed -e 's/_icmp6_filter/ICMPv6Filter/' \
716 -e 's/data/Data/' \
717 -e 's/filt/Filt/' \
718 >> ${OUT}
720 # We need ICMPv6Filter to compile the syscall package.
721 if ! grep 'type ICMPv6Filter ' ${OUT} > /dev/null 2>&1; then
722 echo 'type ICMPv6Filter struct { Data [8]uint32 }' >> ${OUT}
725 # The ip6_mtuinfo struct.
726 grep '^type _ip6_mtuinfo ' gen-sysinfo.go | \
727 sed -e 's/_ip6_mtuinfo/IPv6MTUInfo/' \
728 -e 's/ip6m_addr/Addr/' \
729 -e 's/_sockaddr_in6/RawSockaddrInet6/' \
730 -e 's/ip6m_mtu/Mtu/' \
731 >> ${OUT}
733 # We need IPv6MTUInfo to compile the syscall package.
734 if ! grep 'type IPv6MTUInfo ' ${OUT} >/dev/null 2>&1; then
735 echo 'type IPv6MTUInfo struct { Addr RawSockaddrInet6; Mtu uint32; }' >> ${OUT}
737 if ! grep 'const _sizeof_ip6_mtuinfo = ' ${OUT} >/dev/null 2>&1; then
738 echo 'const SizeofIPv6MTUInfo = 32' >> ${OUT}
741 # Try to guess the type to use for fd_set.
742 fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
743 fds_bits_type="_C_long"
744 if test "$fd_set" != ""; then
745 fds_bits_type=`echo $fd_set | sed -e 's/.*[]]\([^;]*\); }$/\1/'`
747 echo "type fds_bits_type $fds_bits_type" >> ${OUT}
749 # The addrinfo struct.
750 grep '^type _addrinfo ' gen-sysinfo.go | \
751 sed -e 's/_addrinfo/Addrinfo/g' \
752 -e 's/ ai_/ Ai_/g' \
753 >> ${OUT}
755 # The addrinfo and nameinfo flags and errors.
756 grep '^const _AI_' gen-sysinfo.go | \
757 sed -e 's/^\(const \)_\(AI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
758 grep '^const _EAI_' gen-sysinfo.go | \
759 sed -e 's/^\(const \)_\(EAI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
760 grep '^const _NI_' gen-sysinfo.go | \
761 sed -e 's/^\(const \)_\(NI_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
763 # If nothing else defined EAI_OVERFLOW, make sure it has a value.
764 if ! grep "const EAI_OVERFLOW " ${OUT} >/dev/null 2>&1; then
765 echo "const EAI_OVERFLOW = 0" >> ${OUT}
768 # The passwd struct.
769 grep '^type _passwd ' gen-sysinfo.go | \
770 sed -e 's/_passwd/Passwd/' \
771 -e 's/ pw_/ Pw_/g' \
772 >> ${OUT}
774 # The group struct.
775 grep '^type _group ' gen-sysinfo.go | \
776 sed -e 's/_group/Group/' \
777 -e 's/ gr_/ Gr_/g' \
778 >> ${OUT}
780 # The ioctl flags for the controlling TTY.
781 grep '^const _TIOC' gen-sysinfo.go | \
782 grep -v '_val =' | \
783 sed -e 's/^\(const \)_\(TIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
784 grep '^const _TUNSET' gen-sysinfo.go | \
785 grep -v '_val =' | \
786 sed -e 's/^\(const \)_\(TUNSET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
787 # We need TIOCGWINSZ.
788 if ! grep '^const TIOCGWINSZ' ${OUT} >/dev/null 2>&1; then
789 if grep '^const _TIOCGWINSZ_val' ${OUT} >/dev/null 2>&1; then
790 echo 'const TIOCGWINSZ = _TIOCGWINSZ_val' >> ${OUT}
793 if ! grep '^const TIOCSWINSZ' ${OUT} >/dev/null 2>&1; then
794 if grep '^const _TIOCSWINSZ_val' ${OUT} >/dev/null 2>&1; then
795 echo 'const TIOCSWINSZ = _TIOCSWINSZ_val' >> ${OUT}
798 if ! grep '^const TIOCNOTTY' ${OUT} >/dev/null 2>&1; then
799 if grep '^const _TIOCNOTTY_val' ${OUT} >/dev/null 2>&1; then
800 echo 'const TIOCNOTTY = _TIOCNOTTY_val' >> ${OUT}
803 if ! grep '^const TIOCSCTTY' ${OUT} >/dev/null 2>&1; then
804 if grep '^const _TIOCSCTTY_val' ${OUT} >/dev/null 2>&1; then
805 echo 'const TIOCSCTTY = _TIOCSCTTY_val' >> ${OUT}
808 if ! grep '^const TIOCGPGRP' ${OUT} >/dev/null 2>&1; then
809 if grep '^const _TIOCGPGRP_val' ${OUT} >/dev/null 2>&1; then
810 echo 'const TIOCGPGRP = _TIOCGPGRP_val' >> ${OUT}
813 if ! grep '^const TIOCSPGRP' ${OUT} >/dev/null 2>&1; then
814 if grep '^const _TIOCSPGRP_val' ${OUT} >/dev/null 2>&1; then
815 echo 'const TIOCSPGRP = _TIOCSPGRP_val' >> ${OUT}
818 if ! grep '^const TIOCGPTN' ${OUT} >/dev/null 2>&1; then
819 if grep '^const _TIOCGPTN_val' ${OUT} >/dev/null 2>&1; then
820 echo 'const TIOCGPTN = _TIOCGPTN_val' >> ${OUT}
823 if ! grep '^const TIOCSPTLCK' ${OUT} >/dev/null 2>&1; then
824 if grep '^const _TIOCSPTLCK_val' ${OUT} >/dev/null 2>&1; then
825 echo 'const TIOCSPTLCK = _TIOCSPTLCK_val' >> ${OUT}
828 if ! grep '^const TIOCGDEV' ${OUT} >/dev/null 2>&1; then
829 if grep '^const _TIOCGDEV_val' ${OUT} >/dev/null 2>&1; then
830 echo 'const TIOCGDEV = _TIOCGDEV_val' >> ${OUT}
833 if ! grep '^const TIOCSIG' ${OUT} >/dev/null 2>&1; then
834 if grep '^const _TIOCSIG_val' ${OUT} >/dev/null 2>&1; then
835 echo 'const TIOCSIG = _TIOCSIG_val' >> ${OUT}
839 if ! grep '^const TUNSETNOCSUM' ${OUT} >/dev/null 2>&1; then
840 if grep '^const _TUNSETNOCSUM_val' ${OUT} >/dev/null 2>&1; then
841 echo 'const TUNSETNOCSUM = _TUNSETNOCSUM_val' >> ${OUT}
845 if ! grep '^const TUNSETDEBUG' ${OUT} >/dev/null 2>&1; then
846 if grep '^const _TUNSETDEBUG_val' ${OUT} >/dev/null 2>&1; then
847 echo 'const TUNSETDEBUG = _TUNSETDEBUG_val' >> ${OUT}
851 if ! grep '^const TUNSETIFF' ${OUT} >/dev/null 2>&1; then
852 if grep '^const _TUNSETIFF_val' ${OUT} >/dev/null 2>&1; then
853 echo 'const TUNSETIFF = _TUNSETIFF_val' >> ${OUT}
857 if ! grep '^const TUNSETPERSIST' ${OUT} >/dev/null 2>&1; then
858 if grep '^const _TUNSETPERSIST_val' ${OUT} >/dev/null 2>&1; then
859 echo 'const TUNSETPERSIST = _TUNSETPERSIST_val' >> ${OUT}
863 if ! grep '^const TUNSETOWNER' ${OUT} >/dev/null 2>&1; then
864 if grep '^const _TUNSETOWNER_val' ${OUT} >/dev/null 2>&1; then
865 echo 'const TUNSETOWNER = _TUNSETOWNER_val' >> ${OUT}
869 if ! grep '^const TUNSETLINK' ${OUT} >/dev/null 2>&1; then
870 if grep '^const _TUNSETLINK_val' ${OUT} >/dev/null 2>&1; then
871 echo 'const TUNSETLINK = _TUNSETLINK_val' >> ${OUT}
875 if ! grep '^const TUNSETGROUP' ${OUT} >/dev/null 2>&1; then
876 if grep '^const _TUNSETGROUP_val' ${OUT} >/dev/null 2>&1; then
877 echo 'const TUNSETGROUP = _TUNSETGROUP_val' >> ${OUT}
881 if ! grep '^const TUNGETFEATURES' ${OUT} >/dev/null 2>&1; then
882 if grep '^const _TUNGETFEATURES_val' ${OUT} >/dev/null 2>&1; then
883 echo 'const TUNGETFEATURES = _TUNGETFEATURES_val' >> ${OUT}
887 if ! grep '^const TUNSETOFFLOAD' ${OUT} >/dev/null 2>&1; then
888 if grep '^const _TUNSETOFFLOAD_val' ${OUT} >/dev/null 2>&1; then
889 echo 'const TUNSETOFFLOAD = _TUNSETOFFLOAD_val' >> ${OUT}
893 if ! grep '^const TUNSETTXFILTER' ${OUT} >/dev/null 2>&1; then
894 if grep '^const _TUNSETTXFILTER_val' ${OUT} >/dev/null 2>&1; then
895 echo 'const TUNSETTXFILTER = _TUNSETTXFILTER_val' >> ${OUT}
899 if ! grep '^const TUNGETIFF' ${OUT} >/dev/null 2>&1; then
900 if grep '^const _TUNGETIFF_val' ${OUT} >/dev/null 2>&1; then
901 echo 'const TUNGETIFF = _TUNGETIFF_val' >> ${OUT}
905 if ! grep '^const TUNGETSNDBUF' ${OUT} >/dev/null 2>&1; then
906 if grep '^const _TUNGETSNDBUF_val' ${OUT} >/dev/null 2>&1; then
907 echo 'const TUNGETSNDBUF = _TUNGETSNDBUF_val' >> ${OUT}
911 if ! grep '^const TUNSETSNDBUF' ${OUT} >/dev/null 2>&1; then
912 if grep '^const _TUNSETSNDBUF_val' ${OUT} >/dev/null 2>&1; then
913 echo 'const TUNSETSNDBUF = _TUNSETSNDBUF_val' >> ${OUT}
917 if ! grep '^const TUNATTACHFILTER' ${OUT} >/dev/null 2>&1; then
918 if grep '^const _TUNATTACHFILTER_val' ${OUT} >/dev/null 2>&1; then
919 echo 'const TUNATTACHFILTER = _TUNATTACHFILTER_val' >> ${OUT}
923 if ! grep '^const TUNDETACHFILTER' ${OUT} >/dev/null 2>&1; then
924 if grep '^const _TUNDETACHFILTER_val' ${OUT} >/dev/null 2>&1; then
925 echo 'const TUNDETACHFILTER = _TUNDETACHFILTER_val' >> ${OUT}
929 if ! grep '^const TUNGETVNETHDRSZ' ${OUT} >/dev/null 2>&1; then
930 if grep '^const _TUNGETVNETHDRSZ_val' ${OUT} >/dev/null 2>&1; then
931 echo 'const TUNGETVNETHDRSZ = _TUNGETVNETHDRSZ_val' >> ${OUT}
935 if ! grep '^const TUNSETVNETHDRSZ' ${OUT} >/dev/null 2>&1; then
936 if grep '^const _TUNSETVNETHDRSZ_val' ${OUT} >/dev/null 2>&1; then
937 echo 'const TUNSETVNETHDRSZ = _TUNSETVNETHDRSZ_val' >> ${OUT}
941 if ! grep '^const TUNSETQUEUE' ${OUT} >/dev/null 2>&1; then
942 if grep '^const _TUNSETQUEUE_val' ${OUT} >/dev/null 2>&1; then
943 echo 'const TUNSETQUEUE = _TUNSETQUEUE_val' >> ${OUT}
948 if ! grep '^const TUNSETIFINDEX' ${OUT} >/dev/null 2>&1; then
949 if grep '^const _TUNSETIFINDEX_val' ${OUT} >/dev/null 2>&1; then
950 echo 'const TUNSETIFINDEX = _TUNSETIFINDEX_val' >> ${OUT}
954 if ! grep '^const TUNGETFILTER' ${OUT} >/dev/null 2>&1; then
955 if grep '^const _TUNGETFILTER_val' ${OUT} >/dev/null 2>&1; then
956 echo 'const TUNGETFILTER = _TUNGETFILTER_val' >> ${OUT}
960 # The ioctl flags for terminal control
961 grep '^const _TC[GS]ET' gen-sysinfo.go | grep -v _val | \
962 sed -e 's/^\(const \)_\(TC[GS]ET[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
963 if ! grep '^const TCGETS' ${OUT} >/dev/null 2>&1; then
964 if grep '^const _TCGETS_val' ${OUT} >/dev/null 2>&1; then
965 echo 'const TCGETS = _TCGETS_val' >> ${OUT}
968 if ! grep '^const TCSETS' ${OUT} >/dev/null 2>&1; then
969 if grep '^const _TCSETS_val' ${OUT} >/dev/null 2>&1; then
970 echo 'const TCSETS = _TCSETS_val' >> ${OUT}
974 # ioctl constants. Might fall back to 0 if TIOCNXCL is missing, too, but
975 # needs handling in syscalls.exec.go.
976 if ! grep '^const _TIOCSCTTY ' gen-sysinfo.go >/dev/null 2>&1; then
977 if grep '^const _TIOCNXCL ' gen-sysinfo.go >/dev/null 2>&1; then
978 echo "const TIOCSCTTY = TIOCNXCL" >> ${OUT}
982 # If nothing else defined TIOCSCTTY, make sure it has a value.
983 if ! grep "const TIOCSCTTY " ${OUT} >/dev/null 2>&1; then
984 echo "const TIOCSCTTY = 0" >> ${OUT}
987 # The nlmsghdr struct.
988 grep '^type _nlmsghdr ' gen-sysinfo.go | \
989 sed -e 's/_nlmsghdr/NlMsghdr/' \
990 -e 's/nlmsg_len/Len/' \
991 -e 's/nlmsg_type/Type/' \
992 -e 's/nlmsg_flags/Flags/' \
993 -e 's/nlmsg_seq/Seq/' \
994 -e 's/nlmsg_pid/Pid/' \
995 >> ${OUT}
997 # The nlmsg flags and operators.
998 grep '^const _NLM' gen-sysinfo.go | \
999 sed -e 's/^\(const \)_\(NLM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1001 # NLMSG_HDRLEN is defined as an expression using sizeof.
1002 if ! grep '^const NLMSG_HDRLEN' ${OUT} > /dev/null 2>&1; then
1003 if grep '^const _sizeof_nlmsghdr ' ${OUT} > /dev/null 2>&1; then
1004 echo 'const NLMSG_HDRLEN = (_sizeof_nlmsghdr + (NLMSG_ALIGNTO-1)) &^ (NLMSG_ALIGNTO-1)' >> ${OUT}
1008 # The rtmsg struct.
1009 grep '^type _rtmsg ' gen-sysinfo.go | \
1010 sed -e 's/_rtmsg/RtMsg/' \
1011 -e 's/rtm_family/Family/' \
1012 -e 's/rtm_dst_len/Dst_len/' \
1013 -e 's/rtm_src_len/Src_len/' \
1014 -e 's/rtm_tos/Tos/' \
1015 -e 's/rtm_table/Table/' \
1016 -e 's/rtm_protocol/Protocol/' \
1017 -e 's/rtm_scope/Scope/' \
1018 -e 's/rtm_type/Type/' \
1019 -e 's/rtm_flags/Flags/' \
1020 >> ${OUT}
1022 # The rtgenmsg struct.
1023 grep '^type _rtgenmsg ' gen-sysinfo.go | \
1024 sed -e 's/_rtgenmsg/RtGenmsg/' \
1025 -e 's/rtgen_family/Family/' \
1026 >> ${OUT}
1028 # The rt_msghdr struct.
1029 grep '^type _rt_msghdr ' gen-sysinfo.go | \
1030 sed -e 's/_rt_msghdr/RtMsghdr/g' \
1031 -e 's/rtm_msglen/Msglen/' \
1032 -e 's/rtm_version/Version/' \
1033 -e 's/rtm_type/Type/' \
1034 -e 's/rtm_index/Index/' \
1035 -e 's/rtm_flags/Flags/' \
1036 -e 's/rtm_addrs/Addrs/' \
1037 -e 's/rtm_pid/Pid/' \
1038 -e 's/rtm_seq/Seq/' \
1039 -e 's/rtm_errno/Errno/' \
1040 -e 's/rtm_use/Use/' \
1041 -e 's/rtm_inits/Inits/' \
1042 -e 's/rtm_rmx/Rmx/' \
1043 -e 's/_rt_metrics/RtMetrics/' \
1044 >> ${OUT}
1046 # The rt_metrics struct.
1047 grep '^type _rt_metrics ' gen-sysinfo.go | \
1048 sed -e 's/_rt_metrics/RtMetrics/g' \
1049 -e 's/rmx_locks/Locks/' \
1050 -e 's/rmx_mtu/Mtu/' \
1051 -e 's/rmx_hopcount/Hopcount/' \
1052 -e 's/rmx_recvpipe/Recvpipe/' \
1053 -e 's/rmx_sendpipe/Sendpipe/' \
1054 -e 's/rmx_ssthresh/Ssthresh/' \
1055 -e 's/rmx_rtt/Rtt/' \
1056 -e 's/rmx_rttvar/Rttvar/' \
1057 -e 's/rmx_expire/Expire/' \
1058 -e 's/rmx_pksent/Pksent/' \
1059 >> ${OUT}
1061 # The routing message flags.
1062 grep '^const _RT_' gen-sysinfo.go | \
1063 sed -e 's/^\(const \)_\(RT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1064 grep '^const _RTA' gen-sysinfo.go | \
1065 sed -e 's/^\(const \)_\(RTA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1066 grep '^const _RTF' gen-sysinfo.go | \
1067 sed -e 's/^\(const \)_\(RTF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1068 grep '^const _RTCF' gen-sysinfo.go | \
1069 sed -e 's/^\(const \)_\(RTCF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1070 grep '^const _RTM' gen-sysinfo.go | \
1071 sed -e 's/^\(const \)_\(RTM[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1072 if test "${GOOS}" = "netbsd"; then
1073 if ! grep "RTM_RESOLVE" ${OUT} >/dev/null 2>&1; then
1074 # NetBSD 8.0 removed RTM_RESOLVE, but it is part of the syscall package's
1075 # stable API, so add it manually.
1076 echo "const RTM_RESOLVE = 0xb" >> ${OUT}
1079 grep '^const _RTN' gen-sysinfo.go | \
1080 sed -e 's/^\(const \)_\(RTN[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1081 grep '^const _RTPROT' gen-sysinfo.go | \
1082 sed -e 's/^\(const \)_\(RTPROT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1084 # The ifinfomsg struct.
1085 grep '^type _ifinfomsg ' gen-sysinfo.go | \
1086 sed -e 's/_ifinfomsg/IfInfomsg/' \
1087 -e 's/ifi_family/Family/' \
1088 -e 's/ifi_type/Type/' \
1089 -e 's/ifi_index/Index/' \
1090 -e 's/ifi_flags/Flags/' \
1091 -e 's/ifi_change/Change/' \
1092 >> ${OUT}
1094 # The if_msghdr struct. Upstream uses inconsistent capitalization for this type
1095 # on AIX, so we do too.
1096 ifmsghdr_name=IfMsghdr
1097 if test "${GOOS}" = "aix"; then
1098 ifmsghdr_name=IfMsgHdr
1100 grep '^type _if_msghdr ' gen-sysinfo.go | \
1101 sed -e "s/_if_msghdr/${ifmsghdr_name}/" \
1102 -e 's/ifm_msglen/Msglen/' \
1103 -e 's/ifm_version/Version/' \
1104 -e 's/ifm_type/Type/' \
1105 -e 's/ifm_addrs/Addrs/' \
1106 -e 's/ifm_flags/Flags/' \
1107 -e 's/ifm_index/Index/' \
1108 -e 's/ifm_addrlen/Addrlen/' \
1109 >> ${OUT}
1111 # The if_announcemsghdr struct.
1112 grep '^type _if_announcemsghdr ' gen-sysinfo.go | \
1113 sed -e 's/_if_announcemsghdr/IfAnnounceMsghdr/g' \
1114 -e 's/ifan_msglen/Msglen/' \
1115 -e 's/ifan_version/Version/' \
1116 -e 's/ifan_type/Type/' \
1117 -e 's/ifan_index/Index/' \
1118 -e 's/ifan_name/Name/' \
1119 -e 's/ifan_what/What/' \
1120 >> ${OUT}
1122 # The interface information types and flags.
1123 grep '^const _IFA' gen-sysinfo.go | \
1124 sed -e 's/^\(const \)_\(IFA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1125 grep '^const _IFLA' gen-sysinfo.go | \
1126 sed -e 's/^\(const \)_\(IFLA[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1127 grep '^const _IFF' gen-sysinfo.go | \
1128 sed -e 's/^\(const \)_\(IFF[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1129 grep '^const _IFNAMSIZ' gen-sysinfo.go | \
1130 sed -e 's/^\(const \)_\(IFNAMSIZ[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1131 grep '^const _SIOC' gen-sysinfo.go | \
1132 grep -v '_val =' | \
1133 sed -e 's/^\(const \)_\(SIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1135 if ! grep '^const SIOCGIFMTU' ${OUT} >/dev/null 2>&1; then
1136 if grep '^const _SIOCGIFMTU_val' ${OUT} >/dev/null 2>&1; then
1137 echo 'const SIOCGIFMTU = _SIOCGIFMTU_val' >> ${OUT}
1141 # The ifaddrmsg struct.
1142 grep '^type _ifaddrmsg ' gen-sysinfo.go | \
1143 sed -e 's/_ifaddrmsg/IfAddrmsg/' \
1144 -e 's/ifa_family/Family/' \
1145 -e 's/ifa_prefixlen/Prefixlen/' \
1146 -e 's/ifa_flags/Flags/' \
1147 -e 's/ifa_scope/Scope/' \
1148 -e 's/ifa_index/Index/' \
1149 >> ${OUT}
1151 # The ifa_msghdr struct.
1152 grep '^type _ifa_msghdr ' gen-sysinfo.go | \
1153 sed -e 's/_ifa_msghdr/IfaMsghdr/g' \
1154 -e 's/ifam_msglen/Msglen/' \
1155 -e 's/ifam_version/Version/' \
1156 -e 's/ifam_type/Type/' \
1157 -e 's/ifam_addrs/Addrs/' \
1158 -e 's/ifam_flags/Flags/' \
1159 -e 's/ifam_metric/Metric/' \
1160 -e 's/ifam_index/Index/' \
1161 >> ${OUT}
1163 # The rtattr struct.
1164 grep '^type _rtattr ' gen-sysinfo.go | \
1165 sed -e 's/_rtattr/RtAttr/' \
1166 -e 's/rta_len/Len/' \
1167 -e 's/rta_type/Type/' \
1168 >> ${OUT}
1170 # The bpf_version struct.
1171 grep '^type _bpf_version ' gen-sysinfo.go | \
1172 sed -e 's/_bpf_version/BpfVersion/g' \
1173 -e 's/bv_major/Major/' \
1174 -e 's/bv_minor/Minor/' \
1175 >> ${OUT}
1177 # The bpf_stat struct.
1178 grep '^type _bpf_stat ' gen-sysinfo.go | \
1179 sed -e 's/_bpf_stat/BpfStat/g' \
1180 -e 's/bs_recv/Recv/' \
1181 -e 's/bs_drop/Drop/' \
1182 -e 's/bs_capt/Capt/' \
1183 -e 's/bs_padding/Padding/' \
1184 >> ${OUT}
1186 # The bpf_insn struct.
1187 grep '^type _bpf_insn ' gen-sysinfo.go | \
1188 sed -e 's/_bpf_insn/BpfInsn/g' \
1189 -e 's/code/Code/' \
1190 -e 's/jt/Jt/' \
1191 -e 's/jf/Jf/' \
1192 -e 's/k/K/' \
1193 >> ${OUT}
1195 # The bpf_program struct.
1196 grep '^type _bpf_program ' gen-sysinfo.go | \
1197 sed -e 's/_bpf_program/BpfProgram/g' \
1198 -e 's/bf_len/Len/' \
1199 -e 's/bf_insns/Insns/' \
1200 -e 's/_bpf_insn/BpfInsn/' \
1201 >> ${OUT}
1203 # The BPF ioctl constants.
1204 grep '^const _BIOC' gen-sysinfo.go | \
1205 grep -v '_val =' | \
1206 sed -e 's/^\(const \)_\(BIOC[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1207 for c in BIOCFLUSH BIOCGBLEN BIOCGDLT BIOCGETIF BIOCGHDRCMPLT BIOCGRTIMEOUT \
1208 BIOCGSTATS BIOCIMMEDIATE BIOCPROMISC BIOCSBLEN BIOCSDLT BIOCSETF \
1209 BIOCSETIF BIOCSHDRCMPLT BIOCSRTIMEOUT BIOCVERSION
1211 if ! grep "^const ${c}" ${OUT} >/dev/null 2>&1; then
1212 if grep "^const _${c}_val" ${OUT} >/dev/null 2>&1; then
1213 echo "const ${c} = _${c}_val" >> ${OUT}
1216 done
1218 # The in_pktinfo struct.
1219 grep '^type _in_pktinfo ' gen-sysinfo.go | \
1220 sed -e 's/_in_pktinfo/Inet4Pktinfo/' \
1221 -e 's/ipi_ifindex/Ifindex/' \
1222 -e 's/ipi_spec_dst/Spec_dst/' \
1223 -e 's/ipi_addr/Addr/' \
1224 -e 's/_in_addr/[4]byte/g' \
1225 >> ${OUT}
1227 # The in6_pktinfo struct.
1228 grep '^type _in6_pktinfo ' gen-sysinfo.go | \
1229 sed -e 's/_in6_pktinfo/Inet6Pktinfo/' \
1230 -e 's/ipi6_addr/Addr/' \
1231 -e 's/ipi6_ifindex/Ifindex/' \
1232 -e 's/_in6_addr/[16]byte/' \
1233 >> ${OUT}
1235 # The termios struct.
1236 grep '^type _termios ' gen-sysinfo.go | \
1237 sed -e 's/_termios/Termios/' \
1238 -e 's/c_iflag/Iflag/' \
1239 -e 's/c_oflag/Oflag/' \
1240 -e 's/c_cflag/Cflag/' \
1241 -e 's/c_lflag/Lflag/' \
1242 -e 's/c_line/Line/' \
1243 -e 's/c_cc/Cc/' \
1244 -e 's/c_ispeed/Ispeed/' \
1245 -e 's/c_ospeed/Ospeed/' \
1246 >> ${OUT}
1248 # The termios constants.
1249 for n in IGNBRK BRKINT IGNPAR PARMRK INPCK ISTRIP INLCR IGNCR ICRNL IUCLC \
1250 IXON IXANY IXOFF IMAXBEL IUTF8 OPOST OLCUC ONLCR OCRNL ONOCR ONLRET \
1251 OFILL OFDEL NLDLY NL0 NL1 CRDLY CR0 CR1 CR2 CR3 CS5 CS6 CS7 CS8 TABDLY \
1252 BSDLY VTDLY FFDLY CBAUD CBAUDEX CSIZE CSTOPB CREAD PARENB PARODD HUPCL \
1253 CLOCAL LOBLK CIBAUD CMSPAR CRTSCTS ISIG ICANON XCASE ECHO ECHOE ECHOK \
1254 ECHONL ECHOCTL ECHOPRT ECHOKE DEFECHO FLUSHO NOFLSH TOSTOP PENDIN IEXTEN \
1255 VINTR VQUIT VERASE VKILL VEOF VMIN VEOL VTIME VEOL2 VSWTCH VSTART VSTOP \
1256 VSUSP VDSUSP VLNEXT VWERASE VREPRINT VDISCARD VSTATUS TCSANOW TCSADRAIN \
1257 TCSAFLUSH TCIFLUSH TCOFLUSH TCIOFLUSH TCOOFF TCOON TCIOFF TCION B0 B50 \
1258 B75 B110 B134 B150 B200 B300 B600 B1200 B1800 B2400 B4800 B9600 B19200 \
1259 B38400 B57600 B115200 B230400 B460800 B500000 B576000 B921600 B1000000 \
1260 B1152000 B1500000 B2000000 B2500000 B3000000 B3500000 B4000000; do
1262 grep "^const _$n " gen-sysinfo.go | \
1263 sed -e 's/^\(const \)_\([^=]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1264 done
1266 # The mount flags
1267 grep '^const _MNT_' gen-sysinfo.go |
1268 sed -e 's/^\(const \)_\(MNT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1269 grep '^const _MS_' gen-sysinfo.go |
1270 sed -e 's/^\(const \)_\(MS_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1272 # The fallocate flags.
1273 grep '^const _FALLOC_' gen-sysinfo.go |
1274 sed -e 's/^\(const \)_\(FALLOC_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1276 # The statfs struct.
1277 # Prefer largefile variant if available.
1278 # CentOS 5 does not have f_flags, so pull from f_spare.
1279 statfs=`grep '^type _statfs64 ' gen-sysinfo.go || true`
1280 if test "$statfs" = ""; then
1281 statfs=`grep '^type _statfs ' gen-sysinfo.go || true`
1283 if ! echo "$statfs" | grep f_flags >/dev/null 2>&1; then
1284 statfs=`echo "$statfs" | sed -e 's/f_spare \[4+1\]\([^ ;]*\)/f_flags \1; f_spare [3+1]\1/'`
1286 echo "$statfs" | sed -e 's/type _statfs64/type Statfs_t/' \
1287 -e 's/type _statfs/type Statfs_t/' \
1288 -e 's/f_type/Type/' \
1289 -e 's/f_bsize/Bsize/' \
1290 -e 's/f_blocks/Blocks/' \
1291 -e 's/f_bfree/Bfree/' \
1292 -e 's/f_bavail/Bavail/' \
1293 -e 's/f_files/Files/' \
1294 -e 's/f_ffree/Ffree/' \
1295 -e 's/f_fsid/Fsid/' \
1296 -e 's/f_namelen/Namelen/' \
1297 -e 's/f_frsize/Frsize/' \
1298 -e 's/f_flags/Flags/' \
1299 -e 's/f_spare/Spare/' \
1300 >> ${OUT}
1302 # The timex struct.
1303 timex=`grep '^type _timex ' gen-sysinfo.go || true`
1304 if test "$timex" = ""; then
1305 timex=`grep '^// type _timex ' gen-sysinfo.go || true`
1306 if test "$timex" != ""; then
1307 timex=`echo $timex | sed -e 's|// ||' -e 's/INVALID-bit-field/int32/g'`
1310 if test "$timex" != ""; then
1311 echo "$timex" | \
1312 sed -e 's/_timex/Timex/' \
1313 -e 's/modes/Modes/' \
1314 -e 's/offset/Offset/' \
1315 -e 's/freq/Freq/' \
1316 -e 's/maxerror/Maxerror/' \
1317 -e 's/esterror/Esterror/' \
1318 -e 's/status/Status/' \
1319 -e 's/constant/Constant/' \
1320 -e 's/precision/Precision/' \
1321 -e 's/tolerance/Tolerance/' \
1322 -e 's/ time / Time /' \
1323 -e 's/tick/Tick/' \
1324 -e 's/ppsfreq/Ppsfreq/' \
1325 -e 's/jitter/Jitter/' \
1326 -e 's/shift/Shift/' \
1327 -e 's/stabil/Stabil/' \
1328 -e 's/jitcnt/Jitcnt/' \
1329 -e 's/calcnt/Calcnt/' \
1330 -e 's/errcnt/Errcnt/' \
1331 -e 's/stbcnt/Stbcnt/' \
1332 -e 's/tai/Tai/' \
1333 -e 's/_timeval/Timeval/' \
1334 >> ${OUT}
1337 # The rlimit struct.
1338 # On systems that use syscall/libcall_posix_largefile.go, use rlimit64
1339 # if it exists.
1340 rlimit="_rlimit"
1341 if test "${GOOS}" = "aix" || test "${GOOS}" = "linux" || (test "${GOOS}" = "solaris" && (test "${GOARCH}" = "386" || test "${GOARCH}" = "sparc")); then
1342 if grep '^type _rlimit64 ' gen-sysinfo.go > /dev/null 2>&1; then
1343 rlimit="_rlimit64"
1346 grep "^type ${rlimit} " gen-sysinfo.go | \
1347 sed -e "s/${rlimit}/Rlimit/" \
1348 -e 's/rlim_cur/Cur/' \
1349 -e 's/rlim_max/Max/' \
1350 >> ${OUT}
1352 # The RLIMIT constants.
1353 grep '^const _RLIMIT_' gen-sysinfo.go |
1354 sed -e 's/^\(const \)_\(RLIMIT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1355 grep '^const _RLIM_' gen-sysinfo.go |
1356 grep -v '^const _RLIM_INFINITY ' |
1357 sed -e 's/^\(const \)_\(RLIM_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1358 rliminf=""
1359 if test "${rlimit}" = "_rlimit64" && grep '^const _RLIM64_INFINITY ' gen-sysinfo.go > /dev/null 2>&1; then
1360 rliminf=`grep '^const _RLIM64_INFINITY ' gen-sysinfo.go | sed -e 's/.* //'`
1361 else
1362 rliminf=`grep '^const _RLIM_INFINITY ' gen-sysinfo.go | sed -e 's/.* //'`
1364 # For compatibility with the gc syscall package, treat 0xffffffffffffffff as -1.
1365 if test "$rliminf" = "0xffffffffffffffff"; then
1366 echo "const RLIM_INFINITY = -1" >> ${OUT}
1367 elif test -n "$rliminf"; then
1368 echo "const RLIM_INFINITY = $rliminf" >> ${OUT}
1371 # The sysinfo struct.
1372 grep '^type _sysinfo ' gen-sysinfo.go | \
1373 sed -e 's/_sysinfo/Sysinfo_t/' \
1374 -e 's/uptime/Uptime/' \
1375 -e 's/loads/Loads/' \
1376 -e 's/totalram/Totalram/' \
1377 -e 's/freeram/Freeram/' \
1378 -e 's/sharedram/Sharedram/' \
1379 -e 's/bufferram/Bufferram/' \
1380 -e 's/totalswap/Totalswap/' \
1381 -e 's/freeswap/Freeswap/' \
1382 -e 's/procs/Procs/' \
1383 -e 's/totalhigh/Totalhigh/' \
1384 -e 's/freehigh/Freehigh/' \
1385 -e 's/mem_unit/Unit/' \
1386 >> ${OUT}
1388 # The utimbuf struct.
1389 grep '^type _utimbuf ' gen-sysinfo.go | \
1390 sed -e 's/_utimbuf/Utimbuf/' \
1391 -e 's/actime/Actime/' \
1392 -e 's/modtime/Modtime/' \
1393 >> ${OUT}
1395 # The LOCK flags for flock.
1396 grep '^const _LOCK_' gen-sysinfo.go |
1397 sed -e 's/^\(const \)_\(LOCK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1399 # The PRIO constants.
1400 grep '^const _PRIO_' gen-sysinfo.go | \
1401 sed -e 's/^\(const \)_\(PRIO_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1403 # The GNU/Linux LINUX_REBOOT flags.
1404 grep '^const _LINUX_REBOOT_' gen-sysinfo.go |
1405 sed -e 's/^\(const \)_\(LINUX_REBOOT_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1407 # The GNU/Linux sock_filter struct.
1408 grep '^type _sock_filter ' gen-sysinfo.go | \
1409 sed -e 's/_sock_filter/SockFilter/' \
1410 -e 's/code/Code/' \
1411 -e 's/jt/Jt/' \
1412 -e 's/jf/Jf/' \
1413 -e 's/k /K /' \
1414 >> ${OUT}
1416 # The GNU/Linux sock_fprog struct.
1417 grep '^type _sock_fprog ' gen-sysinfo.go | \
1418 sed -e 's/_sock_fprog/SockFprog/' \
1419 -e 's/len/Len/' \
1420 -e 's/filter/Filter/' \
1421 -e 's/_sock_filter/SockFilter/' \
1422 >> ${OUT}
1424 # The GNU/Linux filter flags.
1425 grep '^const _BPF_' gen-sysinfo.go | \
1426 sed -e 's/^\(const \)_\(BPF_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1428 # The GNU/Linux nlattr struct.
1429 grep '^type _nlattr ' gen-sysinfo.go | \
1430 sed -e 's/_nlattr/NlAttr/' \
1431 -e 's/nla_len/Len/' \
1432 -e 's/nla_type/Type/' \
1433 >> ${OUT}
1435 # The GNU/Linux nlmsgerr struct.
1436 grep '^type _nlmsgerr ' gen-sysinfo.go | \
1437 sed -e 's/_nlmsgerr/NlMsgerr/' \
1438 -e 's/error/Error/' \
1439 -e 's/msg/Msg/' \
1440 -e 's/_nlmsghdr/NlMsghdr/' \
1441 >> ${OUT}
1443 # The GNU/Linux rtnexthop struct.
1444 grep '^type _rtnexthop ' gen-sysinfo.go | \
1445 sed -e 's/_rtnexthop/RtNexthop/' \
1446 -e 's/rtnh_len/Len/' \
1447 -e 's/rtnh_flags/Flags/' \
1448 -e 's/rtnh_hops/Hops/' \
1449 -e 's/rtnh_ifindex/Ifindex/' \
1450 >> ${OUT}
1452 # The GNU/Linux netlink flags.
1453 grep '^const _NETLINK_' gen-sysinfo.go | \
1454 sed -e 's/^\(const \)_\(NETLINK_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1455 grep '^const _NLA_' gen-sysinfo.go | grep -v '_val =' | \
1456 sed -e 's/^\(const \)_\(NLA_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1458 if ! grep '^const NLA_HDRLEN' ${OUT} >/dev/null 2>&1; then
1459 if grep '^const _NLA_HDRLEN_val' ${OUT} >/dev/null 2>&1; then
1460 echo 'const NLA_HDRLEN = _NLA_HDRLEN_val' >> ${OUT}
1464 # The GNU/Linux packet socket flags.
1465 grep '^const _PACKET_' gen-sysinfo.go | \
1466 sed -e 's/^\(const \)_\(PACKET_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1468 # The GNU/Linux inotify_event struct.
1469 grep '^type _inotify_event ' gen-sysinfo.go | \
1470 sed -e 's/_inotify_event/InotifyEvent/' \
1471 -e 's/wd/Wd/' \
1472 -e 's/mask/Mask/' \
1473 -e 's/cookie/Cookie/' \
1474 -e 's/len/Len/' \
1475 -e 's/name/Name/' \
1476 -e 's/\[\]/[0]/' \
1477 -e 's/\[0\]byte/[0]int8/' \
1478 >> ${OUT}
1480 # The GNU/Linux CLONE flags.
1481 grep '^const _CLONE_' gen-sysinfo.go | \
1482 sed -e 's/^\(const \)_\(CLONE_[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
1483 # We need some CLONE constants that are not defined in older versions
1484 # of glibc.
1485 if ! grep '^const CLONE_NEWUSER ' ${OUT} > /dev/null 2>&1; then
1486 echo "const CLONE_NEWUSER = 0x10000000" >> ${OUT}
1488 if ! grep '^const CLONE_NEWNET ' ${OUT} > /dev/null 2>&1; then
1489 echo "const CLONE_NEWNET = 0x40000000" >> ${OUT}
1492 # Struct sizes.
1493 set cmsghdr Cmsghdr ip_mreq IPMreq ip_mreqn IPMreqn ipv6_mreq IPv6Mreq \
1494 ifaddrmsg IfAddrmsg ifa_msghdr IfaMsghdr ifinfomsg IfInfomsg \
1495 if_msghdr IfMsghdr in_pktinfo Inet4Pktinfo in6_pktinfo Inet6Pktinfo \
1496 inotify_event InotifyEvent linger Linger msghdr Msghdr nlattr NlAttr \
1497 nlmsgerr NlMsgerr nlmsghdr NlMsghdr rtattr RtAttr rt_msghdr RtMsghdr \
1498 rtgenmsg RtGenmsg rtmsg RtMsg rtnexthop RtNexthop \
1499 sock_filter SockFilter sock_fprog SockFprog ucred Ucred \
1500 icmp6_filter ICMPv6Filter ip6_mtuinfo IPv6MTUInfo
1501 while test $# != 0; do
1502 nc=$1
1503 ngo=$2
1504 shift
1505 shift
1506 if grep "^const _sizeof_$nc =" gen-sysinfo.go >/dev/null 2>&1; then
1507 echo "const Sizeof$ngo = _sizeof_$nc" >> ${OUT}
1509 done
1511 # In order to compile the net package, we need some sizes to exist
1512 # even if the types do not.
1513 if ! grep 'const SizeofIPMreq ' ${OUT} >/dev/null 2>&1; then
1514 echo 'const SizeofIPMreq = 8' >> ${OUT}
1516 if ! grep 'const SizeofIPv6Mreq ' ${OUT} >/dev/null 2>&1; then
1517 echo 'const SizeofIPv6Mreq = 20' >> ${OUT}
1519 if ! grep 'const SizeofIPMreqn ' ${OUT} >/dev/null 2>&1; then
1520 echo 'const SizeofIPMreqn = 12' >> ${OUT}
1522 if ! grep 'const SizeofICMPv6Filter ' ${OUT} >/dev/null 2>&1; then
1523 echo 'const SizeofICMPv6Filter = 32' >> ${OUT}
1526 # The Solaris 11 Update 1 _zone_net_addr_t struct.
1527 grep '^type _zone_net_addr_t ' gen-sysinfo.go | \
1528 sed -e 's/_in6_addr/[16]byte/' \
1529 >> ${OUT}
1531 # The Solaris 11.4 _flow_arp_desc_t struct.
1532 grep '^type _flow_arp_desc_t ' gen-sysinfo.go | \
1533 sed -e 's/_in6_addr_t/[16]byte/g' \
1534 >> ${OUT}
1536 # The Solaris 11.4 _flow_l3_desc_t struct.
1537 grep '^type _flow_l3_desc_t ' gen-sysinfo.go | \
1538 sed -e 's/_in6_addr_t/[16]byte/g' \
1539 >> ${OUT}
1541 # The Solaris 11.3 _mac_ipaddr_t struct.
1542 grep '^type _mac_ipaddr_t ' gen-sysinfo.go | \
1543 sed -e 's/_in6_addr_t/[16]byte/g' \
1544 >> ${OUT}
1546 # The Solaris 11.3 _mactun_info_t struct.
1547 grep '^type _mactun_info_t ' gen-sysinfo.go | \
1548 sed -e 's/_in6_addr_t/[16]byte/g' \
1549 >> ${OUT}
1551 # Type 'uint128' is needed in a couple of type definitions on arm64,such
1552 # as _user_fpsimd_struct, _elf_fpregset_t, etc.
1553 if ! grep '^type uint128' ${OUT} > /dev/null 2>&1; then
1554 echo "type uint128 [16]byte" >> ${OUT}
1557 exit $?